# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from auv_msgs/NavigationStatus.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import auv_msgs.msg
import geographic_msgs.msg
import geometry_msgs.msg
import std_msgs.msg

class NavigationStatus(genpy.Message):
  _md5sum = "3b6f0debc53f1eacc07c1295f8c6666a"
  _type = "auv_msgs/NavigationStatus"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# Sent by the navigator at 5-10 Hz.

Header 	header

geographic_msgs/GeoPoint global_position
geographic_msgs/GeoPoint origin

# NED position and altitude in metres. 
NED position
float32 altitude

# Body velocities in metres/sec., "water-velocity"
geometry_msgs/Point body_velocity
# Velocities measured wrt the seafloor/ground in metres/sec.
geometry_msgs/Point seafloor_velocity

# Orientation and orientation rate are in radians and radians/sec using RPY
geometry_msgs/Vector3 orientation
geometry_msgs/Vector3 orientation_rate

# Variances for position and orientation
NED position_variance
geometry_msgs/Vector3 orientation_variance

# Status and associated constants (flags)
# These flags are here for legacy reasons.
# We need a wider adoption of this package to rethink flags, get in contact if you have suggestions.
# RESERVED RANGE: 0-100.
uint8 status
uint8 STATUS_FAULT = 0
uint8 STATUS_LOCAL_FRAME_OK = 1
uint8 STATUS_GLOBAL_FRAME_OK = 2
uint8 STATUS_POSITION_OK = 3
uint8 STATUS_ESTIMATION_ERROR_OK  = 8
uint8 STATUS_WATER_VELOCITY_OK = 16
uint8 STATUS_GROUND_VELOCITY_OK = 32
uint8 STATUS_VELOCITY_OK = 48
uint8 STATUS_ALL_OK = 59
# Use custom codes >100

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geographic_msgs/GeoPoint
# Geographic point, using the WGS 84 reference ellipsoid.

# Latitude [degrees]. Positive is north of equator; negative is south
# (-90 <= latitude <= +90).
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is
# west (-180 <= longitude <= +180). At the poles, latitude is -90 or
# +90, and longitude is irrelevant, but must be in range.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid (NaN if unspecified).
float64 altitude

================================================================================
MSG: auv_msgs/NED
# Position or velocity in the right-handed NED coordinate frame.

# metres north, positive towards true north.
float64 north

# metres east, positive towards true east.
float64 east

# metres down, positive towards the centre of the earth.
float64 depth

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z"""
  # Pseudo-constants
  STATUS_FAULT = 0
  STATUS_LOCAL_FRAME_OK = 1
  STATUS_GLOBAL_FRAME_OK = 2
  STATUS_POSITION_OK = 3
  STATUS_ESTIMATION_ERROR_OK = 8
  STATUS_WATER_VELOCITY_OK = 16
  STATUS_GROUND_VELOCITY_OK = 32
  STATUS_VELOCITY_OK = 48
  STATUS_ALL_OK = 59

  __slots__ = ['header','global_position','origin','position','altitude','body_velocity','seafloor_velocity','orientation','orientation_rate','position_variance','orientation_variance','status']
  _slot_types = ['std_msgs/Header','geographic_msgs/GeoPoint','geographic_msgs/GeoPoint','auv_msgs/NED','float32','geometry_msgs/Point','geometry_msgs/Point','geometry_msgs/Vector3','geometry_msgs/Vector3','auv_msgs/NED','geometry_msgs/Vector3','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,global_position,origin,position,altitude,body_velocity,seafloor_velocity,orientation,orientation_rate,position_variance,orientation_variance,status

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NavigationStatus, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.global_position is None:
        self.global_position = geographic_msgs.msg.GeoPoint()
      if self.origin is None:
        self.origin = geographic_msgs.msg.GeoPoint()
      if self.position is None:
        self.position = auv_msgs.msg.NED()
      if self.altitude is None:
        self.altitude = 0.
      if self.body_velocity is None:
        self.body_velocity = geometry_msgs.msg.Point()
      if self.seafloor_velocity is None:
        self.seafloor_velocity = geometry_msgs.msg.Point()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Vector3()
      if self.orientation_rate is None:
        self.orientation_rate = geometry_msgs.msg.Vector3()
      if self.position_variance is None:
        self.position_variance = auv_msgs.msg.NED()
      if self.orientation_variance is None:
        self.orientation_variance = geometry_msgs.msg.Vector3()
      if self.status is None:
        self.status = 0
    else:
      self.header = std_msgs.msg.Header()
      self.global_position = geographic_msgs.msg.GeoPoint()
      self.origin = geographic_msgs.msg.GeoPoint()
      self.position = auv_msgs.msg.NED()
      self.altitude = 0.
      self.body_velocity = geometry_msgs.msg.Point()
      self.seafloor_velocity = geometry_msgs.msg.Point()
      self.orientation = geometry_msgs.msg.Vector3()
      self.orientation_rate = geometry_msgs.msg.Vector3()
      self.position_variance = auv_msgs.msg.NED()
      self.orientation_variance = geometry_msgs.msg.Vector3()
      self.status = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_9df18dB().pack(_x.global_position.latitude, _x.global_position.longitude, _x.global_position.altitude, _x.origin.latitude, _x.origin.longitude, _x.origin.altitude, _x.position.north, _x.position.east, _x.position.depth, _x.altitude, _x.body_velocity.x, _x.body_velocity.y, _x.body_velocity.z, _x.seafloor_velocity.x, _x.seafloor_velocity.y, _x.seafloor_velocity.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation_rate.x, _x.orientation_rate.y, _x.orientation_rate.z, _x.position_variance.north, _x.position_variance.east, _x.position_variance.depth, _x.orientation_variance.x, _x.orientation_variance.y, _x.orientation_variance.z, _x.status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.global_position is None:
        self.global_position = geographic_msgs.msg.GeoPoint()
      if self.origin is None:
        self.origin = geographic_msgs.msg.GeoPoint()
      if self.position is None:
        self.position = auv_msgs.msg.NED()
      if self.body_velocity is None:
        self.body_velocity = geometry_msgs.msg.Point()
      if self.seafloor_velocity is None:
        self.seafloor_velocity = geometry_msgs.msg.Point()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Vector3()
      if self.orientation_rate is None:
        self.orientation_rate = geometry_msgs.msg.Vector3()
      if self.position_variance is None:
        self.position_variance = auv_msgs.msg.NED()
      if self.orientation_variance is None:
        self.orientation_variance = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 221
      (_x.global_position.latitude, _x.global_position.longitude, _x.global_position.altitude, _x.origin.latitude, _x.origin.longitude, _x.origin.altitude, _x.position.north, _x.position.east, _x.position.depth, _x.altitude, _x.body_velocity.x, _x.body_velocity.y, _x.body_velocity.z, _x.seafloor_velocity.x, _x.seafloor_velocity.y, _x.seafloor_velocity.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation_rate.x, _x.orientation_rate.y, _x.orientation_rate.z, _x.position_variance.north, _x.position_variance.east, _x.position_variance.depth, _x.orientation_variance.x, _x.orientation_variance.y, _x.orientation_variance.z, _x.status,) = _get_struct_9df18dB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_9df18dB().pack(_x.global_position.latitude, _x.global_position.longitude, _x.global_position.altitude, _x.origin.latitude, _x.origin.longitude, _x.origin.altitude, _x.position.north, _x.position.east, _x.position.depth, _x.altitude, _x.body_velocity.x, _x.body_velocity.y, _x.body_velocity.z, _x.seafloor_velocity.x, _x.seafloor_velocity.y, _x.seafloor_velocity.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation_rate.x, _x.orientation_rate.y, _x.orientation_rate.z, _x.position_variance.north, _x.position_variance.east, _x.position_variance.depth, _x.orientation_variance.x, _x.orientation_variance.y, _x.orientation_variance.z, _x.status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.global_position is None:
        self.global_position = geographic_msgs.msg.GeoPoint()
      if self.origin is None:
        self.origin = geographic_msgs.msg.GeoPoint()
      if self.position is None:
        self.position = auv_msgs.msg.NED()
      if self.body_velocity is None:
        self.body_velocity = geometry_msgs.msg.Point()
      if self.seafloor_velocity is None:
        self.seafloor_velocity = geometry_msgs.msg.Point()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Vector3()
      if self.orientation_rate is None:
        self.orientation_rate = geometry_msgs.msg.Vector3()
      if self.position_variance is None:
        self.position_variance = auv_msgs.msg.NED()
      if self.orientation_variance is None:
        self.orientation_variance = geometry_msgs.msg.Vector3()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 221
      (_x.global_position.latitude, _x.global_position.longitude, _x.global_position.altitude, _x.origin.latitude, _x.origin.longitude, _x.origin.altitude, _x.position.north, _x.position.east, _x.position.depth, _x.altitude, _x.body_velocity.x, _x.body_velocity.y, _x.body_velocity.z, _x.seafloor_velocity.x, _x.seafloor_velocity.y, _x.seafloor_velocity.z, _x.orientation.x, _x.orientation.y, _x.orientation.z, _x.orientation_rate.x, _x.orientation_rate.y, _x.orientation_rate.z, _x.position_variance.north, _x.position_variance.east, _x.position_variance.depth, _x.orientation_variance.x, _x.orientation_variance.y, _x.orientation_variance.z, _x.status,) = _get_struct_9df18dB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_9df18dB = None
def _get_struct_9df18dB():
    global _struct_9df18dB
    if _struct_9df18dB is None:
        _struct_9df18dB = struct.Struct("<9df18dB")
    return _struct_9df18dB
