# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from auv_msgs/WorldWaypointRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import auv_msgs.msg
import geometry_msgs.msg
import std_msgs.msg

class WorldWaypointRequest(genpy.Message):
  _md5sum = "cb80c1e42bc09e9c27be72f3245795c3"
  _type = "auv_msgs/WorldWaypointRequest"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# World frame (absolute) waypoint request to pilot.

Header header

# Waypoint request
auv_msgs/NED position
geometry_msgs/Vector3 orientation 

# Axes of control to disable, in body frame.
bool[6] disable_axis # x y z r p y

# Tolerances are in body frame, zero indicates pilot default should be used.
geometry_msgs/Vector3 position_tolerance
geometry_msgs/Vector3 orientation_tolerance

# Capping speeds in 6DOF
geometry_msgs/Twist twist_limit

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: auv_msgs/NED
# Position or velocity in the right-handed NED coordinate frame.

# metres north, positive towards true north.
float64 north

# metres east, positive towards true east.
float64 east

# metres down, positive towards the centre of the earth.
float64 depth

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular
"""
  __slots__ = ['header','position','orientation','disable_axis','position_tolerance','orientation_tolerance','twist_limit']
  _slot_types = ['std_msgs/Header','auv_msgs/NED','geometry_msgs/Vector3','bool[6]','geometry_msgs/Vector3','geometry_msgs/Vector3','geometry_msgs/Twist']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,position,orientation,disable_axis,position_tolerance,orientation_tolerance,twist_limit

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(WorldWaypointRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.position is None:
        self.position = auv_msgs.msg.NED()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Vector3()
      if self.disable_axis is None:
        self.disable_axis = [False] * 6
      if self.position_tolerance is None:
        self.position_tolerance = geometry_msgs.msg.Vector3()
      if self.orientation_tolerance is None:
        self.orientation_tolerance = geometry_msgs.msg.Vector3()
      if self.twist_limit is None:
        self.twist_limit = geometry_msgs.msg.Twist()
    else:
      self.header = std_msgs.msg.Header()
      self.position = auv_msgs.msg.NED()
      self.orientation = geometry_msgs.msg.Vector3()
      self.disable_axis = [False] * 6
      self.position_tolerance = geometry_msgs.msg.Vector3()
      self.orientation_tolerance = geometry_msgs.msg.Vector3()
      self.twist_limit = geometry_msgs.msg.Twist()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_6d().pack(_x.position.north, _x.position.east, _x.position.depth, _x.orientation.x, _x.orientation.y, _x.orientation.z))
      buff.write(_get_struct_6B().pack(*self.disable_axis))
      _x = self
      buff.write(_get_struct_12d().pack(_x.position_tolerance.x, _x.position_tolerance.y, _x.position_tolerance.z, _x.orientation_tolerance.x, _x.orientation_tolerance.y, _x.orientation_tolerance.z, _x.twist_limit.linear.x, _x.twist_limit.linear.y, _x.twist_limit.linear.z, _x.twist_limit.angular.x, _x.twist_limit.angular.y, _x.twist_limit.angular.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.position is None:
        self.position = auv_msgs.msg.NED()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Vector3()
      if self.position_tolerance is None:
        self.position_tolerance = geometry_msgs.msg.Vector3()
      if self.orientation_tolerance is None:
        self.orientation_tolerance = geometry_msgs.msg.Vector3()
      if self.twist_limit is None:
        self.twist_limit = geometry_msgs.msg.Twist()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 48
      (_x.position.north, _x.position.east, _x.position.depth, _x.orientation.x, _x.orientation.y, _x.orientation.z,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 6
      self.disable_axis = _get_struct_6B().unpack(str[start:end])
      self.disable_axis = list(map(bool, self.disable_axis))
      _x = self
      start = end
      end += 96
      (_x.position_tolerance.x, _x.position_tolerance.y, _x.position_tolerance.z, _x.orientation_tolerance.x, _x.orientation_tolerance.y, _x.orientation_tolerance.z, _x.twist_limit.linear.x, _x.twist_limit.linear.y, _x.twist_limit.linear.z, _x.twist_limit.angular.x, _x.twist_limit.angular.y, _x.twist_limit.angular.z,) = _get_struct_12d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_6d().pack(_x.position.north, _x.position.east, _x.position.depth, _x.orientation.x, _x.orientation.y, _x.orientation.z))
      buff.write(self.disable_axis.tostring())
      _x = self
      buff.write(_get_struct_12d().pack(_x.position_tolerance.x, _x.position_tolerance.y, _x.position_tolerance.z, _x.orientation_tolerance.x, _x.orientation_tolerance.y, _x.orientation_tolerance.z, _x.twist_limit.linear.x, _x.twist_limit.linear.y, _x.twist_limit.linear.z, _x.twist_limit.angular.x, _x.twist_limit.angular.y, _x.twist_limit.angular.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.position is None:
        self.position = auv_msgs.msg.NED()
      if self.orientation is None:
        self.orientation = geometry_msgs.msg.Vector3()
      if self.position_tolerance is None:
        self.position_tolerance = geometry_msgs.msg.Vector3()
      if self.orientation_tolerance is None:
        self.orientation_tolerance = geometry_msgs.msg.Vector3()
      if self.twist_limit is None:
        self.twist_limit = geometry_msgs.msg.Twist()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 48
      (_x.position.north, _x.position.east, _x.position.depth, _x.orientation.x, _x.orientation.y, _x.orientation.z,) = _get_struct_6d().unpack(str[start:end])
      start = end
      end += 6
      self.disable_axis = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=6)
      self.disable_axis = list(map(bool, self.disable_axis))
      _x = self
      start = end
      end += 96
      (_x.position_tolerance.x, _x.position_tolerance.y, _x.position_tolerance.z, _x.orientation_tolerance.x, _x.orientation_tolerance.y, _x.orientation_tolerance.z, _x.twist_limit.linear.x, _x.twist_limit.linear.y, _x.twist_limit.linear.z, _x.twist_limit.angular.x, _x.twist_limit.angular.y, _x.twist_limit.angular.z,) = _get_struct_12d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_12d = None
def _get_struct_12d():
    global _struct_12d
    if _struct_12d is None:
        _struct_12d = struct.Struct("<12d")
    return _struct_12d
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_6B = None
def _get_struct_6B():
    global _struct_6B
    if _struct_6B is None:
        _struct_6B = struct.Struct("<6B")
    return _struct_6B
_struct_6d = None
def _get_struct_6d():
    global _struct_6d
    if _struct_6d is None:
        _struct_6d = struct.Struct("<6d")
    return _struct_6d
