// Auto-generated. Do not edit!

// (in-package auv_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let NED = require('./NED.js');
let geometry_msgs = _finder('geometry_msgs');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class WorldWaypointRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.position = null;
      this.orientation = null;
      this.disable_axis = null;
      this.position_tolerance = null;
      this.orientation_tolerance = null;
      this.twist_limit = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('position')) {
        this.position = initObj.position
      }
      else {
        this.position = new NED();
      }
      if (initObj.hasOwnProperty('orientation')) {
        this.orientation = initObj.orientation
      }
      else {
        this.orientation = new geometry_msgs.msg.Vector3();
      }
      if (initObj.hasOwnProperty('disable_axis')) {
        this.disable_axis = initObj.disable_axis
      }
      else {
        this.disable_axis = new Array(6).fill(0);
      }
      if (initObj.hasOwnProperty('position_tolerance')) {
        this.position_tolerance = initObj.position_tolerance
      }
      else {
        this.position_tolerance = new geometry_msgs.msg.Vector3();
      }
      if (initObj.hasOwnProperty('orientation_tolerance')) {
        this.orientation_tolerance = initObj.orientation_tolerance
      }
      else {
        this.orientation_tolerance = new geometry_msgs.msg.Vector3();
      }
      if (initObj.hasOwnProperty('twist_limit')) {
        this.twist_limit = initObj.twist_limit
      }
      else {
        this.twist_limit = new geometry_msgs.msg.Twist();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type WorldWaypointRequest
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [position]
    bufferOffset = NED.serialize(obj.position, buffer, bufferOffset);
    // Serialize message field [orientation]
    bufferOffset = geometry_msgs.msg.Vector3.serialize(obj.orientation, buffer, bufferOffset);
    // Check that the constant length array field [disable_axis] has the right length
    if (obj.disable_axis.length !== 6) {
      throw new Error('Unable to serialize array field disable_axis - length must be 6')
    }
    // Serialize message field [disable_axis]
    bufferOffset = _arraySerializer.bool(obj.disable_axis, buffer, bufferOffset, 6);
    // Serialize message field [position_tolerance]
    bufferOffset = geometry_msgs.msg.Vector3.serialize(obj.position_tolerance, buffer, bufferOffset);
    // Serialize message field [orientation_tolerance]
    bufferOffset = geometry_msgs.msg.Vector3.serialize(obj.orientation_tolerance, buffer, bufferOffset);
    // Serialize message field [twist_limit]
    bufferOffset = geometry_msgs.msg.Twist.serialize(obj.twist_limit, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type WorldWaypointRequest
    let len;
    let data = new WorldWaypointRequest(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [position]
    data.position = NED.deserialize(buffer, bufferOffset);
    // Deserialize message field [orientation]
    data.orientation = geometry_msgs.msg.Vector3.deserialize(buffer, bufferOffset);
    // Deserialize message field [disable_axis]
    data.disable_axis = _arrayDeserializer.bool(buffer, bufferOffset, 6)
    // Deserialize message field [position_tolerance]
    data.position_tolerance = geometry_msgs.msg.Vector3.deserialize(buffer, bufferOffset);
    // Deserialize message field [orientation_tolerance]
    data.orientation_tolerance = geometry_msgs.msg.Vector3.deserialize(buffer, bufferOffset);
    // Deserialize message field [twist_limit]
    data.twist_limit = geometry_msgs.msg.Twist.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    return length + 150;
  }

  static datatype() {
    // Returns string type for a message object
    return 'auv_msgs/WorldWaypointRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'cb80c1e42bc09e9c27be72f3245795c3';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # World frame (absolute) waypoint request to pilot.
    
    Header header
    
    # Waypoint request
    auv_msgs/NED position
    geometry_msgs/Vector3 orientation 
    
    # Axes of control to disable, in body frame.
    bool[6] disable_axis # x y z r p y
    
    # Tolerances are in body frame, zero indicates pilot default should be used.
    geometry_msgs/Vector3 position_tolerance
    geometry_msgs/Vector3 orientation_tolerance
    
    # Capping speeds in 6DOF
    geometry_msgs/Twist twist_limit
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: auv_msgs/NED
    # Position or velocity in the right-handed NED coordinate frame.
    
    # metres north, positive towards true north.
    float64 north
    
    # metres east, positive towards true east.
    float64 east
    
    # metres down, positive towards the centre of the earth.
    float64 depth
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    ================================================================================
    MSG: geometry_msgs/Twist
    # This expresses velocity in free space broken into its linear and angular parts.
    Vector3  linear
    Vector3  angular
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new WorldWaypointRequest(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.position !== undefined) {
      resolved.position = NED.Resolve(msg.position)
    }
    else {
      resolved.position = new NED()
    }

    if (msg.orientation !== undefined) {
      resolved.orientation = geometry_msgs.msg.Vector3.Resolve(msg.orientation)
    }
    else {
      resolved.orientation = new geometry_msgs.msg.Vector3()
    }

    if (msg.disable_axis !== undefined) {
      resolved.disable_axis = msg.disable_axis;
    }
    else {
      resolved.disable_axis = new Array(6).fill(0)
    }

    if (msg.position_tolerance !== undefined) {
      resolved.position_tolerance = geometry_msgs.msg.Vector3.Resolve(msg.position_tolerance)
    }
    else {
      resolved.position_tolerance = new geometry_msgs.msg.Vector3()
    }

    if (msg.orientation_tolerance !== undefined) {
      resolved.orientation_tolerance = geometry_msgs.msg.Vector3.Resolve(msg.orientation_tolerance)
    }
    else {
      resolved.orientation_tolerance = new geometry_msgs.msg.Vector3()
    }

    if (msg.twist_limit !== undefined) {
      resolved.twist_limit = geometry_msgs.msg.Twist.Resolve(msg.twist_limit)
    }
    else {
      resolved.twist_limit = new geometry_msgs.msg.Twist()
    }

    return resolved;
    }
};

module.exports = WorldWaypointRequest;
